"$@". The "checkout" command is run in the parent of the repository
directory, since the repository isn't checked out yet. All other commands
are run inside the repository, though not necessarily at the top of it.
+
The "MR_REPO" environment variable is set to the path to the top of the
-repository, and "MR_CONFIG" is set to the topmost .mrconfig file used.
+repository, and "MR_CONFIG" is set to the .mrconfig file that defines the
+repo being acted on, or, if the repo is not yet in a config file, the
+.mrconfig file that mr thinks it should be added to.
A few parameters have special meanings:
=item skip
-If the "skip" parameter is set and its command returns nonzero, then B<mr>
+If the "skip" parameter is set and its command returns true, then B<mr>
will skip acting on that repository. The command is passed the action
name in $1.
=item chain
-If the "chain" parameter is set and its command returns nonzero, then B<mr>
+If the "chain" parameter is set and its command returns true, then B<mr>
will try to load a .mrconfig file from the root of the repository. (You
should avoid chaining from repositories with untrusted committers.)
=item deleted
-If the "deleted" parameter is set and its command returns nonzero, then
+If the "deleted" parameter is set and its command returns true, then
B<mr> will treat the repository as deleted. It won't ever actually delete
the repository, but it will warn if it sees the repository's directory.
This is useful when one mrconfig file is shared amoung multiple machines,
my $stats=0;
my $no_recurse=0;
my %config;
+my %configfiles;
my %knownactions;
my %alias;
sub action { #{{{
my ($action, $dir, $topdir, $subdir) = @_;
-
- my $lib= exists $config{$topdir}{$subdir}{lib} ?
- $config{$topdir}{$subdir}{lib}."\n" : "";
+
+ $ENV{MR_CONFIG}=$configfiles{$topdir};
+ my $lib=exists $config{$topdir}{$subdir}{lib} ?
+ $config{$topdir}{$subdir}{lib}."\n" : "";
if (exists $config{$topdir}{$subdir}{deleted}) {
- if (! -d $dir) {
- return;
+ my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
+ print "mr $action: running deleted test >>$test<<\n" if $verbose;
+ my $ret=system($test);
+ if ($ret != 0) {
+ if (($? & 127) == 2) {
+ print STDERR "mr $action: interrupted\n";
+ exit 2;
+ }
+ elsif ($? & 127) {
+ print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
+ }
}
- else {
- my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
- print "mr $action: running deleted test >>$test<<\n" if $verbose;
- my $ret=system($test);
- if ($ret != 0) {
- if (($? & 127) == 2) {
- print STDERR "mr $action: interrupted\n";
- exit 2;
- }
- elsif ($? & 127) {
- print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
- }
- if ($ret >> 8 == 0) {
- print STDERR "mr error: $dir should be deleted yet still exists\n\n";
- push @failed, $dir;
- return;
- }
+ if ($ret >> 8 == 0) {
+ if (-d $dir) {
+ print STDERR "mr error: $dir should be deleted yet still exists\n\n";
+ push @failed, $dir;
+ return;
+ }
+ else {
+ print "mr $action: $dir skipped (as deleted) per config file\n" if $verbose;
+ push @skipped, $dir;
+ return;
}
}
}
print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
exit 1;
}
- if ($ret >> 8 == 0) {
- print "mr $action: $dir skipped per config file\n" if $verbose;
- push @skipped, $dir;
- return;
- }
+ }
+ if ($ret >> 8 == 0) {
+ print "mr $action: $dir skipped per config file\n" if $verbose;
+ push @skipped, $dir;
+ return;
}
}
else {
$config{$dir}{$section}{$parameter}=$value;
$knownactions{$parameter}=1;
+ if (! exists $configfiles{$dir}) {
+ $configfiles{$dir}=abs_path($f);
+ }
if ($parameter eq 'chain' &&
length $dir && $section ne "DEFAULT" &&
-e $dir.$section."/.mrconfig") {
if [ -z "$url" ]; then
error "cannot determine svn url"
fi
- echo "Registering svn url: $url"
+ echo "Registering svn url: $url in $MR_CONFIG"
mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
elif [ -d .git ]; then
url=$(LANG=C git-config --get remote.origin.url)
if [ -z "$url" ]; then
error "cannot determine git url"
fi
- echo "Registering git url: $url"
+ echo "Registering git url: $url in $MR_CONFIG"
mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
elif [ -d .bzr ]; then
url=$(cat .bzr/branch/parent)
if [ -z "$url" ]; then
error "cannot determine bzr url"
fi
- echo "Registering bzr url: $url"
+ echo "Registering bzr url: $url in $MR_CONFIG"
mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
else
error "unable to register this repo type"